﻿----------------------------------------
-- Epic Gem List v 0.2, Copyright 2010 Wolfgang Rufeger, wolfgang@rufeger.de
-- 0.1	Initial version
-- 0.2	Added blue cataclysm gems with test on first load
-- 0.3  Added JC only gems, cataclysm green and WotLK blue gems
----------------------------------------
EGL_SOCKETSELECT = EGL_GemLocaleText["socketselect"];
EGL_STATSELECT = EGL_GemLocaleText["statselect"];
EGL_CLOSE = EGL_GemLocaleText["close"];
EGL_JC = EGL_GemLocaleText["jc"];
EGL_VERSION = "ver 0.3 by Ydy @ Shattrath"

local ldb = LibStub:GetLibrary("LibDataBroker-1.1",true)

ldb:NewDataObject("Epic Gem List", {
    type = "launcher",
	label = "EGL",
	OnClick = function(_, msg)
        if msg == "LeftButton" then
	        if EGL_Form:IsVisible() then
		        EGL_Form:Hide()
		    else
		        EGL_Form:Show()
	        end
        end
    end,
	icon = "Interface\\AddOns\\EpicGemList\\icon",
	OnTooltipShow = function(tooltip)
		if not tooltip or not tooltip.AddLine then return end
		tooltip:AddLine("Epic Gem List")
	end,
})

if(EGL_Options == nil) then
    EGL_Options = {};
end

if ( EGL_Options["SelectedStat"]  == nil ) then
    EGL_Options["SelectedStat"] = 0;
end

if ( EGL_Options["SelectedSlot"] == nil ) then
    EGL_Options["SelectedSlot"] = 0;
end

if (EGL_Options["jc"] == nil ) then
	EGL_Options["jc"] = false;
	EGL_Options["jc_cata"] = false;
end

if (EGL_Options["jc"] and EGL_Options["cataclysm"]) then
	EGL_Options["jc_cata"] = true;
end
if (EGL_Options["jc"] == false) then
	EGL_Options["jc_cata"] = false
end

function out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
 --UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end




function EGL_SlashCommandHandler(msg)
	if EGL_Form:IsVisible() then
		EGL_Form:Hide()
	else
		EGL_Form:Show()
	end
end


function EGL_OnLoad(this)
	SELECTEDITEM = 0;
  
	out("EpicGemList Loaded...");
	SLASH_EGL1 = "/epicgemlist";
	SLASH_EGL2 = "/egl";
	SlashCmdList["EGL"] = function(msg)
		EGL_SlashCommandHandler(msg);
	end
	if EGL_Form:IsVisible() then
		EGL_Form:Hide()
	else
		EGL_Form:Show()
	end
	EGL_Options = {};
	EGL_Options["SelectedSlot"] = 0;
	EGL_Options["SelectedStat"] = 0;
	iteminfo = GetItemInfo(52203); -- test on one cataclysm gem
	if iteminfo then
		EGL_Options["cataclysm"] = true;
	else
		EGL_Options["cataclysm"] = false;
	end
	EGL_SlotDropDown_Init();
	EGL_StatDropDown_Init();
end

function EGLItem_OnEnter(this)
  EGLTooltip:ClearLines();
  local id = this:GetID()+ FauxScrollFrame_GetOffset(EGL_ScrollBar);  
  
  if id ~= nil then
  	local iteminfo = GetItemInfo(EGL[id]);
    local itemName, itemLink, itemQuality, itemLevel, itemMinLevel, itemType, itemSubType, itemCount, itemEquipLoc, itemTexture = GetItemInfo(EGL[id]);

    EGLTooltip:SetOwner(this, "ANCHOR_RIGHT", -(this:GetWidth() / 2), 24);
    EGLTooltip:SetHyperlink("item:"..EGL[id]..":0:0:0");
	EGLTooltip:AddLine("Item Level: "..itemLevel);
    EGLTooltip:Show();

	if EnhTooltip and EnhTooltip.TooltipCall then   
	  quantity = 1;
	  EnhTooltip.TooltipCall(EGLTooltip, itemName, itemLink, itemQuality, quantity);
	end
  end 
end

function EGLItem_OnLeave()
  SELECTEDITEM = 0;
  EGLTooltip:Hide();
end

function EGLItem_OnClick(this)
	local EGL_Skill_ID;
	local id = this:GetID() + FauxScrollFrame_GetOffset(EGL_ScrollBar);
	local iteminfo = GetItemInfo(EGL[id]);
    local itemName, itemLink, itemQuality, itemLevel, itemMinLevel, itemType, itemSubType, itemCount, itemEquipLoc, itemTexture = GetItemInfo(EGL[id])
	local editbox = ChatFrameEditBox
	if not editbox then
		editbox = ChatEdit_GetActiveWindow();
    end 
    if AuctionFrame then
        if (AuctionFrame:IsVisible() and CanSendAuctionQuery() and iteminfo) then
            BrowseName:SetText(itemName);
            AuctionFrameBrowse_Search();
        end
    end
	if (editbox and IsShiftKeyDown()) then
		editbox:Insert(itemLink); 
	end
	-- if (IsAltKeyDown()) then
		-- if (EGL_Data[EGL[id]] ~= nil) then
			-- EGL_Skill_ID = EGL_Data[EGL[id]]["ts"];
		-- elseif (EGL_Data_Cata[EGL[id]] ~= nil) then
			-- EGL_Skill_ID = EGL_Data[EGL[id]]["ts"];
		-- elseif (EGL_Data_JC[EGL[id]] ~= nil) then
			-- EGL_Skill_ID = EGL_Data[EGL[id]]["ts"];
		-- end
		-- if EGL_Skill_ID ~= nil then
			-- DoTradeSkill(EGL_Skill_ID,1);
			-- out("SkillID: "..EGL_Skill_ID);
		-- end
	-- end

end

function EGL_CheckButton_OnClick(this)
	if (EGL_Options["jc"]) then
		EGL_Options["jc"] = false;
		EGL_Options["jc_cata"] = false;
		out("EGL: Hide jewelcrafter gems ...");
		EGL_ScrollBar_Update();
	else
		EGL_Options["jc"] = true;
		if (EGL_Options["cataclysm"]) then
			EGL_Options["jc_cata"] = true;
		end
		out("EGL: Show jewelcrafter gems ...");
		EGL_ScrollBar_Update();
	end
end

function EGL_SlotDropDown_Init()
	local entries = table.getn(EGL_GemLocaleSlot);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_GemLocaleSlot[i];
		info.value = value;
		info.text = text;
		info.func = EGL_SlotDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_SlotDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_SlotDropDown, EGL_SlotDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_SlotDropDown, EGL_Options["SelectedSlot"]+1);
    -- UIDropDownMenu_SetWidth(110, EpicGemListSlotDropDown);
    EGL_ScrollBar_Update();
end

function EGL_SlotDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_SlotDropDown, i);
    EGL_Options["SelectedSlot"] = i-1;
    EGL_ScrollBar_Update();
end

function EGL_StatDropDown_Init()
	local entries = table.getn(EGL_GemLocaleStat);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_GemLocaleStat[i];
		info.text = text;
		info.value = value;
		info.func = EGL_StatDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_StatDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_StatDropDown, EGL_StatDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_StatDropDown, EGL_Options["SelectedStat"]+1);
    -- UIDropDownMenu_SetWidth(110, EpicGemListSlotDropDown);
    EGL_ScrollBar_Update();
end

function EGL_StatDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_StatDropDown, i);
    EGL_Options["SelectedStat"] = i-1;
    EGL_ScrollBar_Update();
end


function EGL_ScrollBar_Update()
    local line, lineplusoffset, text, extratext;
    local currentgem;    
    EGL = {};    
    currentgem = 1;

    for value,_ in pairs(EGL_Data) do    
	    additem = true;	    	    
		if EGL_Options["SelectedStat"] ~= 0 and 
		   (EGL_Data[value]["stat1"] ~= EGL_Options["SelectedStat"] and EGL_Data[value]["stat2"] ~= EGL_Options["SelectedStat"] and EGL_Data[value]["stat3"] ~= EGL_Options["SelectedStat"]) then
			additem = false;
	    end	    
	    if EGL_Options["SelectedSlot"] ~= 0 and 
	           ((EGL_Options["SelectedSlot"] == 1 and EGL_Data[value]["red"] == false) or
			   (EGL_Options["SelectedSlot"] == 2 and EGL_Data[value]["blue"] == false) or
			   (EGL_Options["SelectedSlot"] == 3 and EGL_Data[value]["yellow"] == false) or
			   (EGL_Options["SelectedSlot"] == 4 and EGL_Data[value]["meta"] == false)) then
			additem = false;   
		end	    
        if additem == true then
            tinsert(EGL, value);
        end        
        currentgem = currentgem + 1;
    end      
	
	if (EGL_Options["cataclysm"]) then	-- if info of cataclysm gems can be retrieved
		for value,_ in pairs(EGL_Data_Cata) do    
			additem = true;	    	    
			if EGL_Options["SelectedStat"] ~= 0 and 
			(EGL_Data_Cata[value]["stat1"] ~= EGL_Options["SelectedStat"] and EGL_Data_Cata[value]["stat2"] ~= EGL_Options["SelectedStat"] and EGL_Data_Cata[value]["stat3"] ~= EGL_Options["SelectedStat"]) then
				additem = false;
			end	    
			if EGL_Options["SelectedSlot"] ~= 0 and 
			((EGL_Options["SelectedSlot"] == 1 and EGL_Data_Cata[value]["red"] == false) or
			(EGL_Options["SelectedSlot"] == 2 and EGL_Data_Cata[value]["blue"] == false) or
			(EGL_Options["SelectedSlot"] == 3 and EGL_Data_Cata[value]["yellow"] == false) or
			(EGL_Options["SelectedSlot"] == 4 and EGL_Data_Cata[value]["meta"] == false)) then
				additem = false;   
			end	    
			if additem == true then
				tinsert(EGL, value);
			end        
			currentgem = currentgem + 1;
		end      
	end
	
	if (EGL_Options["jc"]) then	-- if info of cataclysm gems can be retrieved
		for value,_ in pairs(EGL_Data_JC) do    
			additem = true;	    	    
			if EGL_Options["SelectedStat"] ~= 0 and 
			(EGL_Data_JC[value]["stat1"] ~= EGL_Options["SelectedStat"] and EGL_Data_JC[value]["stat2"] ~= EGL_Options["SelectedStat"] and EGL_Data_JC[value]["stat3"] ~= EGL_Options["SelectedStat"]) then
				additem = false;
			end	    
			if EGL_Options["SelectedSlot"] ~= 0 and 
			((EGL_Options["SelectedSlot"] == 1 and EGL_Data_JC[value]["red"] == false) or
			(EGL_Options["SelectedSlot"] == 2 and EGL_Data_JC[value]["blue"] == false) or
			(EGL_Options["SelectedSlot"] == 3 and EGL_Data_JC[value]["yellow"] == false) or
			(EGL_Options["SelectedSlot"] == 4 and EGL_Data_JC[value]["meta"] == false)) then
				additem = false;   
			end	    
			if additem == true then
				tinsert(EGL, value);
			end        
			currentgem = currentgem + 1;
		end      
	end

	if (EGL_Options["jc_cata"]) then	-- if info of cataclysm gems can be retrieved
		for value,_ in pairs(EGL_Data_Cata_JC) do    
			additem = true;	    	    
			if EGL_Options["SelectedStat"] ~= 0 and 
			(EGL_Data_Cata_JC[value]["stat1"] ~= EGL_Options["SelectedStat"] and EGL_Data_Cata_JC[value]["stat2"] ~= EGL_Options["SelectedStat"] and EGL_Data_Cata_JC[value]["stat3"] ~= EGL_Options["SelectedStat"]) then
				additem = false;
			end	    
			if EGL_Options["SelectedSlot"] ~= 0 and 
			((EGL_Options["SelectedSlot"] == 1 and EGL_Data_Cata_JC[value]["red"] == false) or
			(EGL_Options["SelectedSlot"] == 2 and EGL_Data_Cata_JC[value]["blue"] == false) or
			(EGL_Options["SelectedSlot"] == 3 and EGL_Data_Cata_JC[value]["yellow"] == false) or
			(EGL_Options["SelectedSlot"] == 4 and EGL_Data_Cata_JC[value]["meta"] == false)) then
				additem = false;   
			end	    
			if additem == true then
				tinsert(EGL, value);
			end        
			currentgem = currentgem + 1;
		end      
	end
	
	
	
    table.sort(EGL, EGL_SortResults);
    EGL_ShowGemList();    
end

function EGL_SortResults(a, b)
	local iteminfoA = GetItemInfo(a);
	local iteminfoB = GetItemInfo(b);
    local itemNameA, itemLinkA, itemQualityA, itemLevelA = GetItemInfo(a);
    local itemNameB, itemLinkB, itemQualityB, itemLevelB = GetItemInfo(b);
	if ((iteminfoA ~= nil) and (iteminfoB ~= nil)) then
		if itemLevelA ~= itemLevelB then	-- Sort by item level first
			return itemLevelA > itemLevelB;
		end
		if itemQualityA ~= itemQualityB then	-- Sort by item quality second
			return itemQualityA > itemQualityB;
		end
		if itemNameA and itemNameB then		-- if same item level, sort by name
			return itemNameA < itemNameB;
		end
	end
	return a < b;						-- sort by id, if no name
end

local function EnumerateTooltipLines_helper(...)
    for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
				if (text ~= nil) then
					out(text);
				end
        end
    end
end




function EGL_ShowGemList()  
	local i, item, itemn, itemi;
    MaxItems = table.getn(EGL);    
    FauxScrollFrame_Update(EGL_ScrollBar,MaxItems,15,16);
    for i=1,15 do
		item = _G["EGLItem_"..i];
		itemn = _G["EGLItem_"..i.."_Name"];
		itemi = _G["EGLItem_"..i.."_Icon"];
        lineplusoffset = i + FauxScrollFrame_GetOffset(EGL_ScrollBar);
		if lineplusoffset < MaxItems+1 then
			itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(EGL[lineplusoffset]);
			if itemName then
				if itemn ~= nil then
					itemn:SetText(ITEM_QUALITY_COLORS[itemRarity].hex..itemName);
				end
				if itemi ~= nil then
					itemi:SetTexture(itemTexture);
				end
				if item ~= nil then
					item:Show();
					--ScanTooltip:SetHyperlink("item:"..EGL[lineplusoffset]..":0:0:0");
					--EnumerateTooltipLines_helper(ScanTooltip:GetRegions());
				end
			end
		else
			if item ~= nil then
				item:Hide();
			end
		end
    end
end

